package org.xtext.example.mydsl.generator;

import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.xtext.example.mydsl.pEnum.Model;
import org.xtext.example.mydsl.pEnum.PEnum;
import org.xtext.example.mydsl.pEnum.PEnumElement;
import org.xtext.example.mydsl.pEnum.PEnumElementParamaterValue;

@SuppressWarnings("all")
public class PEnumGenerator implements IGenerator {
  public void doGenerate(final Resource resource, final IFileSystemAccess fsa) {
    EList<EObject> _contents = resource.getContents();
    Iterable<Model> _filter = IterableExtensions.<Model>filter(_contents, org.xtext.example.mydsl.pEnum.Model.class);
    for (final Model model : _filter) {
      EList<PEnum> _penums = model.getPenums();
      for (final PEnum penum : _penums) {
        String _name = penum.getName();
        String _operator_plus = StringExtensions.operator_plus(_name, ".java");
        CharSequence _generatePEnum = this.generatePEnum(penum);
        fsa.generateFile(_operator_plus, _generatePEnum);
      }
    }
  }
  
  public CharSequence generatePEnum(final PEnum penum) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public enum ");
    String _name = penum.getName();
    _builder.append(_name, "");
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    {
      EList<PEnumElement> _elements = penum.getElements();
      for(final PEnumElement element : _elements) {
        _builder.append("\t");
        String _name_1 = element.getName();
        _builder.append(_name_1, "	");
        _builder.append("(\"");
        String _text = this.text(element);
        _builder.append(_text, "	");
        _builder.append("\"");
        String _passParameters = this.passParameters(element);
        _builder.append(_passParameters, "	");
        _builder.append("),");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append(";");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("private String text;");
    _builder.newLine();
    {
      EList<String> _parameterNameList = penum.getParameterNameList();
      for(final String name : _parameterNameList) {
        _builder.append("\t");
        _builder.append("private boolean ");
        _builder.append(name, "	");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("private ");
    String _name_2 = penum.getName();
    _builder.append(_name_2, "	");
    _builder.append("(String text");
    String _defParameters = this.defParameters(penum);
    _builder.append(_defParameters, "	");
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("this.text = text;");
    _builder.newLine();
    {
      EList<String> _parameterNameList_1 = penum.getParameterNameList();
      for(final String name_1 : _parameterNameList_1) {
        _builder.append("\t\t");
        _builder.append("this.");
        _builder.append(name_1, "		");
        _builder.append(" = ");
        _builder.append(name_1, "		");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public String getText() {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return text;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    {
      EList<String> _parameterNameList_2 = penum.getParameterNameList();
      for(final String name_2 : _parameterNameList_2) {
        _builder.newLine();
        _builder.append("\t");
        _builder.append("public boolean is");
        String _firstUpper = StringExtensions.toFirstUpper(name_2);
        _builder.append(_firstUpper, "	");
        _builder.append("() {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("\t");
        _builder.append("return ");
        _builder.append(name_2, "		");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public String passParameters(final PEnumElement element) {
    EList<PEnumElementParamaterValue> _parameterValueList = element.getParameterValueList();
    final Function1<PEnumElementParamaterValue,String> _function = new Function1<PEnumElementParamaterValue,String>() {
        public String apply(final PEnumElementParamaterValue value) {
          boolean _isValue = value.isValue();
          String _operator_plus = StringExtensions.operator_plus(", ", Boolean.valueOf(_isValue));
          return _operator_plus;
        }
      };
    List<String> _map = ListExtensions.<PEnumElementParamaterValue, String>map(_parameterValueList, _function);
    String _join = IterableExtensions.join(_map, "");
    return _join;
  }
  
  public String defParameters(final PEnum penum) {
    EList<String> _parameterNameList = penum.getParameterNameList();
    final Function1<String,String> _function = new Function1<String,String>() {
        public String apply(final String name) {
          String _operator_plus = StringExtensions.operator_plus(", boolean ", name);
          return _operator_plus;
        }
      };
    List<String> _map = ListExtensions.<String, String>map(_parameterNameList, _function);
    String _join = IterableExtensions.join(_map, "");
    return _join;
  }
  
  public String text(final PEnumElement element) {
    String _xifexpression = null;
    String _alternateText = element.getAlternateText();
    boolean _operator_notEquals = ObjectExtensions.operator_notEquals(_alternateText, null);
    if (_operator_notEquals) {
      String _alternateText_1 = element.getAlternateText();
      _xifexpression = _alternateText_1;
    } else {
      String _name = element.getName();
      String _lowerCase = _name.toLowerCase();
      String _firstUpper = StringExtensions.toFirstUpper(_lowerCase);
      String _replace = _firstUpper.replace("_", " ");
      _xifexpression = _replace;
    }
    return _xifexpression;
  }
}
